/*
 * Nombre del Proyecto:
     proyecto2MICROCON.c
 * Nombre del Autor:
     Irving Darly Garofalo Yanez, 2012.
 * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC
*/

unsigned int conversion(unsigned int num);
unsigned int digmassig, dig1, digmenossig, pot_analg, displaymenossig, displaymassig;
unsigned int i,com,dig_com,dig_1,dig_2,display_me,display_ma;
void ejercicio1();
void ejercicio2();
void display_dig();


void main() {

  ANSEL  = 0;
  ANSELH = 0;
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;

  TRISA  = 0xFF;              // PORTA is input
  TRISB  = 0;                 // PORTB como salida
  TRISC  = 0;                 // PORTC is output
  TRISD  = 0;                 // PORTD is output
  PORTB = 0;

  ADC_Init();

  do {
     PORTD = 0b00000110;
     PORTC = 0b00111101;
    if (RA1_bit) {                    // button on RA0 pressed
      Delay_ms(40);
      ejercicio1();
     }

    if (RA2_bit) {                    // button on RA1 pressed
      Delay_ms(40);
      ejercicio2();
     }

  } while(1);
}
unsigned int conversion(unsigned int num) {
         switch (num) {
                case 0 : return 0x3F;
                case 1 : return 0x06;
                case 2 : return 0x5B;
                case 3 : return 0x4F;
                case 4 : return 0x66;
                case 5 : return 0x6D;
                case 6 : return 0x7D;
                case 7 : return 0x07;
                case 8 : return 0x7F;
                case 9 : return 0x6F;
         }
}

void ejercicio1() {

   ANSEL  = 0xFF;
     while(1){
          pot_analg = ADC_read(0);
          dig1=(pot_analg*5*19.8)/1023;
          PORTB=dig1;
          digmenossig= dig1%10;
          displaymenossig= conversion(digmenossig);
          PORTC= displaymenossig;
          digmassig=(dig1/10)%10;
          displaymassig=conversion(digmassig);
          PORTD= displaymassig;

     }
}

void ejercicio2() {

  do {
      PORTD = 0b00011110;
      PORTC = 0b00111110;
      i=0;
      dig_com=0;

     if (RA1_bit) {                    // button on RA0 pressed
        do {
                  display_dig();
                  PORTB = 0b00000001;
                  if (PORTB == 0b00000001) {
                     com=1;
                   };
                  if (RA2_bit==1 && com==1) {
                     dig_com++;
                     display_dig();
                   };
                   Delay_ms(100);
                   PORTB = 0b00000010;
                   Delay_ms(100);
                   PORTB = 0b00000100;
                   Delay_ms(100);
                   PORTB = 0b00001000;
                   Delay_ms(100);
                   PORTB = 0b00010000;
                   Delay_ms(100);
                   PORTB = 0b00100000;
                   Delay_ms(100);
                   PORTB = 0b01000000;
                   Delay_ms(100);
                   PORTB = 0b10000000;
                   if (PORTB == 0b10000000) {
                       com=2;
                      };
                   if (RA2_bit == 1 && com==2) {
                      dig_com++;
                      display_dig();
                     };
                   Delay_ms(100);
                   PORTB = 0b01000000;
                   Delay_ms(100);
                   PORTB = 0b00100000;
                   Delay_ms(100);
                   PORTB = 0b00010000;
                   Delay_ms(100);
                   PORTB = 0b00001000;
                   Delay_ms(100);
                   PORTB = 0b00000100;
                   Delay_ms(100);
                   PORTB = 0b00000100;
                   Delay_ms(100);
                   PORTB = 0b00000010;
                   Delay_ms(100);
                   PORTB = 0b00000001;
                   if (dig_com == 10) {
                      i=21;
                     };
                   i++;
          } while(i<20);
     }
    PORTC == 0b00110110;
    PORTD == 0b01110001;

  } while(1);
}


void display_dig() {
     dig_1=dig_com%10;
     display_me = conversion(dig_1);
     PORTC = display_me;
     dig_2=(dig_com/10)%10;
     display_ma = conversion(dig_2);
     PORTD = display_ma;
 }